using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Drawing;
using System.Collections;
using System.Text;

// The DataSource SHOULD BE a DataSet. 
// No check is implemented on this point.

namespace MSDN
{
	public class SuperDataGrid : System.Web.UI.WebControls.DataGrid
	{
			
		private int m_CreatePageTimes  = 0;
		private Color m_mouseover=Color.Empty;
		private Color m_mouseout=Color.Empty;
		private static DataView m_dataview ;
		public SuperDataGrid():base()	
		{
			AllowPaging = true;
			PageIndexChanged+=new DataGridPageChangedEventHandler(HyperDataGrid_PageIndexChanged);
			ItemCommand +=new DataGridCommandEventHandler(HyperDataGrid_ItemCommand);
			ItemCreated +=new DataGridItemEventHandler(HyperDataGrid_ItemCreated);
			ItemDataBound +=new DataGridItemEventHandler(HyperDataGrid_ItemDataBound);
			SortCommand +=new DataGridSortCommandEventHandler(HyperDataGrid_SortCommand);
			
			//Page.RegisterClientScriptBlock("SelectOneRow",RegisterScript(SelectedItemStyle.BackColor ));
			//Page.RegisterStartupScript("SelectOneRow",RegisterScript(SelectedItemStyle.BackColor ));
		}

		public void SetCheckBoxClintScript()
		{	
			Page.RegisterClientScriptBlock("SelectOneRow",RegisterScript(Color.Pink ));
		}
	
		string RegisterScript(Color color)
		{
			StringBuilder str=new StringBuilder();
			str.Append("<script language=\"javascript\">");
			str.Append("function SelectOneRow(chkB,oriColor){var xState=chkB.checked;");
			str.Append("if(xState){chkB.parentElement.parentElement.style.backgroundColor='pink';}");
			str.Append("else{chkB.parentElement.parentElement.style.backgroundColor=oriColor;}}");
			str.Append("function SelectAllCheckboxes(spanChk){var xState=spanChk.checked;");
			str.Append("var theBox=spanChk;elm=theBox.form.elements;");
			str.Append("for(i=0;i<elm.length;i++)if(elm[i].type==\"checkbox\" && elm[i].id!=theBox.id){");
			str.Append("if(elm[i].checked!=xState)elm[i].click();}}");
			str.Append("</script>");
			return str.ToString();
		}

		
	/*if(xState)
		{chkB.parentElement.parentElement.style.backgroundColor='lightcoral';  // grdEmployees.SelectedItemStyle.BackColor
		 chkB.parentElement.parentElement.style.color='white'; // grdEmployees.SelectedItemStyle.ForeColor
		}else 
		{chkB.parentElement.parentElement.style.backgroundColor='white'; //grdEmployees.ItemStyle.BackColor
		 chkB.parentElement.parentElement.style.color='black'; //grdEmployees.ItemStyle.ForeColor
		}
	}*/
			

		//declare dataview
		public DataView m_DataView
		{
			get{return m_dataview;}
			set{m_dataview=value;}
		}

		public Color OnMouseOverColor
		{
			get{return m_mouseover;}
			set{m_mouseover=value;}
		}

		public Color OnMouseOutColor
		{
			get{return m_mouseout;}
			set{m_mouseout=value;}
		}

		public event EventHandler UpdateView;//fire databinding event
		public event EventHandler InsertView;
		private void OnUpdateView()
		{
			if (UpdateView != null)
				UpdateView(this, EventArgs.Empty); 
		}

		private void OnInsertView()
		{
			if (InsertView != null)
				InsertView(this, EventArgs.Empty); 
		}

		private void HyperDataGrid_PageIndexChanged(object source, DataGridPageChangedEventArgs e)
		{
			DataGrid detGrid = (DataGrid) source;
			detGrid.CurrentPageIndex = e.NewPageIndex;
			//CurrentPageIndex=e.NewPageIndex;
			m_CreatePageTimes=0;
			OnUpdateView();
		}

		private void HyperDataGrid_ItemCommand(object source, DataGridCommandEventArgs e)
		{
			if (e.CommandName=="alpha")
			{
				
				ViewState["alpha"]=e.CommandArgument;
				m_CreatePageTimes=0;
				CurrentPageIndex=0;
				OnUpdateView();
			}

			if (e.CommandName=="Cancle")
			{
				ShowFooter=false;
			}
			if (e.CommandName=="Insert")
			{
				OnInsertView();
				ShowFooter=false;
			}
		}

		private void HyperDataGrid_ItemCreated(object sender, DataGridItemEventArgs e)
		{
			if (e.Item.ItemType==ListItemType.Header)
			{
				//
				foreach(TableCell c in e.Item.Cells)
				{
					
					if (c.Controls.Count >0 && c.Controls[0].GetType().ToString()=="System.Web.UI.WebControls.DataGridLinkButton")
					{
						if (((LinkButton)c.Controls[0]).Text==(string)ViewState["Sort"])
						{
							Label l=new Label();
							l.Font.Name="Webdings";
							if ((string)ViewState["orderby"]=="asc")
								l.Text="5";
							else
								l.Text="6";
							c.Controls.Add(l);
						}
					}
				}
			}

			if (e.Item.ItemType==ListItemType.Item || e.Item.ItemType==ListItemType.AlternatingItem)
			{
				//System.Drawing.Color col=Color.FromArgb((int)e.Item.BackColor.R,(int)e.Item.BackColor.G,(int)e.Item.BackColor.B)
			
				//string str=e.Item.BackColor;
				if (OnMouseOverColor==Color.Empty)
					OnMouseOverColor=SelectedItemStyle.BackColor;
				if (OnMouseOutColor==Color.Empty)
					OnMouseOutColor=ItemStyle.BackColor;
			/*	
				e.Item.Attributes.Add("onmouseover","this.style.backgroundColor='pink'");//"+OnMouseOverColor+"
				e.Item.Attributes.Add("onmouseout","this.style.backgroundColor='#"+ConvertHex(OnMouseOutColor)+"'");//"+OnMouseOutColor+"
	*/

			}
	
			if (e.Item.ItemType==ListItemType.Footer)
			{
				int i=0;LinkButton lb;
				foreach(TableCell c in e.Item.Cells)
				{

					if (i==0) 
						c.Controls.Add(new CheckBox());
					else if (i==e.Item.Cells.Count-2)
					{
						lb=new LinkButton();
						lb.Text="";
						lb.CommandName="Insert";
						c.Controls.Add(lb);
					}
					else if (i==e.Item.Cells.Count-1)
					{
						lb=new LinkButton();
						lb.Text="ȡ";
						lb.CommandName="Cancle";
						c.Controls.Add(lb);
					}
					else	
						c.Controls.Add(new TextBox());
					i++;
				}
			}

			if (e.Item.ItemType==ListItemType.Pager)
			{
				if (m_CreatePageTimes==0)
				{
					e.Item.Cells[0].Controls.Clear();
					LinkButton l;
					
					for (int i=65;i<65+25;i++)
					{
						l=new LinkButton();
						LiteralControl lc=new LiteralControl();
						lc.Text=" ";
						l.CommandName="alpha";
						l.CommandArgument=Convert.ToChar(i).ToString();
						l.Text=Convert.ToChar(i).ToString();
						e.Item.Cells[0].Controls.Add(l);
						e.Item.Cells[0].Controls.Add(lc);
					}

					l=new LinkButton();
					l.Text="All";
					l.CommandName="alpha";
					l.CommandArgument="";
					e.Item.Cells[0].Controls.Add(l);
					m_CreatePageTimes  ++; 
					
				}
				else if(m_CreatePageTimes==1)
				{
				
					foreach(Control ct in e.Item.Cells[0].Controls)
					{
						switch(ct.GetType().ToString())
						{
							case "System.Web.UI.WebControls.Label":
							{
								Label l=(Label)ct;
								l.Text="ǰҳ["+l.Text+"]";
								break;
							}
							case "System.Web.UI.LiteralControl":
							{
								LiteralControl lc=(LiteralControl)ct;
								lc.Text="|";
								break;
							}
							case "System.Web.UI.WebControls.DataGridLinkButton":
							{
								LinkButton lb=(LinkButton)ct;
								if (e.Item.Cells[0].Controls.IndexOf(ct)==0 && lb.Text=="...")
									lb.Text="[ǰҳ]";
								else if(e.Item.Cells[0].Controls.IndexOf(ct)==e.Item.Cells[0].Controls.Count-1 && lb.Text=="...")
									lb.Text="[ҳ]";
								else
									lb.Text="["+lb.Text+"]ҳ";
							
								break;
							}
						
						}
					}
				}
				
			}
		}



		public override object DataSource
		{
			get
			{
				return base.DataSource;
			}
			set
			{
				base.DataSource = value;
			}
		}


		public override void DataBind()
		{
			if (m_DataView!=null)
			{
				string sort=(string)(ViewState["Sort"]);
				string orderby=(string)(ViewState["orderby"]);
				if (sort!=null)//
					m_DataView.Sort=sort+" "+orderby;
				else
					m_DataView.Sort="CustomerID";
				if ((string)(ViewState["alpha"])!="")
				{
					m_DataView.RowFilter="CustomerID LIKE '"+(string)(ViewState["alpha"])+"%'";
				}
				m_CreatePageTimes=0;
				
			}
			base.DataBind ();
		}

		

		private void HyperDataGrid_ItemDataBound(object sender, DataGridItemEventArgs e)
		{	
			
		}


		private string ConvertHex(Color col)
		{
			string str="";
			str+=Convert.ToString((long)col.R,16);
			str+=Convert.ToString((long)col.G,16);
			str+=Convert.ToString((long)col.B,16);
			return str;
		}

		private void HyperDataGrid_SortCommand(object source, DataGridSortCommandEventArgs e)
		{
			ViewState["Sort"]=e.SortExpression;
			if ((string)ViewState["orderby"]=="asc")
				ViewState["orderby"]="desc";
			else
				ViewState["orderby"]="asc";
			m_CreatePageTimes=0;
//			DataBind();
			OnUpdateView();
		}

	}
}
